/*-----------------------------------------------------------------
   IsHan:  Flag for some usage. (1 / 0)
     Bit 1 -- Indicates Status of Han/Eng Toggle Key. (Han/Eng Mode)
     Bit 2,3 -- Indicates Previos Input Mode used for Move.
      (HanMode: Move 2 bytes, EngMode: Move 1 byte, Enter: New line)
------------------------------------------------------------------*/
char hinput_Cho, hinput_Jung, hinput_Jong, hinput_Jong_tmp,
	hinput_N_Cho, hinput_state=7;

/*------------------------------------------------------------------
   Indicates whether character is Jaeum or not, if Ja then MSB=1
   LSB : 1 - duplicated character(Cho), 0 - if not.
   bit 2 : 1 - duplicated character(Jong), 0 - if not.  
------------------------------------------------------------------*/
int hinput_IsJa[27] = {
  /*  a     b     c     d     e     f     g     h     i     j     k     l */
    0x80, 0x00, 0x80, 0x80, 0x81, 0x80, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
  /*  m     n     o     p     q     r     s     t     u     v     w     x */
    0x00, 0x00, 0x01, 0x01, 0x81, 0x83, 0x80, 0x83, 0x00, 0x80, 0x81, 0x80,
  /*  y     z   dummy */
    0x00, 0x80,  -1 };

/*------------------------------------------------------------------
   Contains Code of duplicated character.
-------------------------------------------------------------------*/
int hinput_Caps[26] = {
/*  A   B   C   D   E   F   G   H   I   J   K   L   M   N */
    0,  0,  0,  0,  6,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  O   P   Q   R   S   T   U   V   W   X   Y   Z */
    6, 12, 10,  3,  3, 12, 22,  0, 15,  0,  0,  0 };
