# -------------------------------------------------------------------------
# 
# Edit this file to reflect to locations of the shared libraries for
# the extensions.  The contents of the variable "tcl_extloadpath"
# tell the extension command where to look for the libraries.
#
set tcl_extloadpath { 
	/home2/j-env/lib
	/home2/j-env/lib/tcl
	/home2/j-env/lib/tk
	/home2/j-env/lib/itcl
	/home2/j-env/lib/tree
	/home2/j-env/lib/dp
	/home2/j-env/lib/itcl/wigwam
	/home2/j-env/lib/dd_protocols
}

# -------------------------------------------------------------------------
# 
# The format of the an entry in the tcl_extensions array is 
# 
#   initRoutine shlib ?shlib...?
#

#
# [incr tcl] library
#

set tcl_extensions(itcl) { Itcl_Init libitcl.so.1.5 }

if ![info exists tk_library] {
    return
}

# -------------------------------------------------------------------------
#
# 	Put extensions that require Tk after this point
#
# -------------------------------------------------------------------------

#
# BLT library 
#

set tcl_extensions(blt) { Blt_Init libBLT.so.1.7 }

#
# DP library 
#

set tcl_extensions(dp) { Tdp_Init libdpnetwork.so.3.1 }

#
# STEAL library 
#

set tcl_extensions(steal) { TkXAccess_Init libtkXAccess.so }

#
# DEBUG library 
#

set tcl_extensions(dbg) { Dbg_Init libtcldbg.so }

#
# DEBUG library 
#

set tcl_extensions(tree) { Tree_Init libtktree.so.3.6 }

#
# DEBUG library 
#

set tcl_extensions(hinput) { Han_Init libhinput.so.1.0 }

#
# VUW widget set (bargraph, piechart, etc.)
#

#set tcl_extensions(vuw) { Vuw_Init libVUW.so.1.0 }
