#!/home2/j-env/bin/wish -f

bind Text <Shift-space> {
	TextHangulBind %W;
}


bind Text <2> {
		if [catch {set newkey [selection get]} ] {
			return
		}
		%W insert insert $newkey
}

proc TextHangulCompose {aWIDGET ch} {

	set linepos [$aWIDGET index insert]
	regexp {([^.]*).([^.]*)} $linepos x line pos
	set Prev "00"

	if { $pos == 0 } {
		set t [Romaji2Han "" $ch];
	} else {
		set Prev [$aWIDGET get $line.[expr $pos - 1]]
		$aWIDGET delete $line.[expr $pos - 1]
		set t [Romaji2Han $Prev $ch]
	}

	$aWIDGET insert insert $t
	$aWIDGET yview -pickplace insert
}



proc TextHangulUnBind {aWIDGET} {

	$aWIDGET configure -kanjifont -kaist-myungjo-medium-r-normal--16-120-100-100-c-160-ksc5601.1987-0;

	bind $aWIDGET <Shift-space> {
		TextHangulBind %W
	}

	bind $aWIDGET <Return> {
		%W insert insert \n
		%W yview -pickplace insert
	}

	bind $aWIDGET <1> {
		set tk_priv(selectMode) char
		%W mark set insert @%x,%y
		%W mark set anchor insert
		if {[lindex [%W config -state] 4] == "normal"} {
			focus %W
		}
	}

	bind $aWIDGET <2> {
		catch {
			%W insert insert [selection get]
			%W yview -pickplace insert
		}
	}

	bind $aWIDGET <BackSpace> {
		tk_textBackspace %W;
		%W yview -pickplace insert
	}

	bind $aWIDGET <Any-KeyPress> {
		if {"%A" != ""} {
			%W insert insert %A
			%W yview -pickplace insert
    	}
	}	

	bind $aWIDGET <KeyPress-a> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-b> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-c> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-d> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-e> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-f> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-g> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-h> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-i> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-j> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-k> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-l> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-m> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-n> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-o> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-p> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-q> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-r> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-s> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-t> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-u> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-v> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-w> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-x> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-y> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-z> {
		%W insert insert %A
		%W yview -pickplace insert
	}

	bind $aWIDGET <KeyPress-A> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-B> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-C> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-D> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-E> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-F> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-G> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-H> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-I> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-J> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-K> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-L> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-M> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-N> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-O> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-P> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-Q> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-R> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-S> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-T> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-U> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-V> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-W> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-X> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-Y> {
		%W insert insert %A
		%W yview -pickplace insert
	}
	bind $aWIDGET <KeyPress-Z> {
		%W insert insert %A
		%W yview -pickplace insert
	}
}


proc TextHangulBind {aWIDGET} {

	InitHanAutomata;
	$aWIDGET configure -kanjifont \
		-kaist-myungjo-bold-r-normal--16-120-100-100-c-160-ksc5601.1987-0

	bind $aWIDGET <Shift-space> {
		TextHangulUnBind %W
	}

	bind $aWIDGET <Return> {
		%W insert insert \n
		%W yview -pickplace insert
	}

	bind $aWIDGET <1> {
		set tk_priv(selectMode) char
		%W mark set insert @%x,%y
		%W mark set anchor insert
		if {[lindex [%W config -state] 4] == "normal"} {
			focus %W
		}
		InitHanAutomata
	}

	bind $aWIDGET <2> {
		catch {
			%W insert insert [selection get]
			%W yview -pickplace insert
		}
		InitHanAutomata
	}

	bind $aWIDGET <BackSpace> {
		tk_textBackspace %W;
		%W yview -pickplace insert
		InitHanAutomata
	}

	bind $aWIDGET <Any-KeyPress> {
		if {"%A" != ""} {
			if [expr [expr [string compare %K "Shift_L"] == 0] || \
					[expr [string compare %K "Shift_R"] == 0] ] {
			} else {
				%W insert insert %A
				%W yview -pickplace insert
				InitHanAutomata
			}
    	}
	}	

	bind $aWIDGET <KeyPress-a> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-b> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-c> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-d> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-e> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-f> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-g> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-h> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-i> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-j> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-k> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-l> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-m> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-n> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-o> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-p> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-q> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-r> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-s> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-t> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-u> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-v> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-w> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-x> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-y> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-z> {TextHangulCompose %W %A}

	bind $aWIDGET <KeyPress-A> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-B> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-C> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-D> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-E> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-F> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-G> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-H> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-I> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-J> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-K> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-L> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-M> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-N> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-O> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-P> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-Q> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-R> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-S> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-T> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-U> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-V> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-W> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-X> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-Y> {TextHangulCompose %W %A}
	bind $aWIDGET <KeyPress-Z> {TextHangulCompose %W %A}
}

