#!/home2/j-env/bin/wish -f

bind Entry <Shift-space> {
	HangulBind %W;
}

bind Entry <2> {
		if [catch {set newkey [selection get]} ] {
			return
		}
		%W insert insert $newkey
}

proc HangulCompose {aWIDGET ch} {

	set insertP [$aWIDGET index insert]
	set Prev "00"

	if { $insertP == 0 } {
		set t [Romaji2Han "" $ch];
	} else {
		set Prev [kstring index [$aWIDGET get] [expr $insertP - 1]];
		$aWIDGET delete [expr $insertP - 1];
		set t [Romaji2Han $Prev $ch];
	}

	$aWIDGET insert insert $t
	tk_entrySeeCaret $aWIDGET
}

proc doHangulBind {aWIDGET} {

	bind $aWIDGET <Shift-space> {HangulBind %W}
}


proc doHangulUnBind {aWIDGET} {

	bind $aWIDGET <Shift-space> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
}


proc HangulUnBind {aWIDGET} {

	$aWIDGET configure -kanjifont -kaist-myungjo-medium-r-normal--16-120-100-100-c-160-ksc5601.1987-0;

	bind $aWIDGET <Shift-space> {
		HangulBind %W
	}

	bind $aWIDGET <1> {
		%W icursor @%x
		%W select from @%x
		if {[lindex [%W config -state] 4] == "normal"} {
			focus %W
		}
	}

	bind $aWIDGET <2> {
		if { [catch {set newkey [selection get]} ]} {
			return
		}
		%W insert insert $newkey
	}

	bind $aWIDGET <BackSpace> {
		tk_entryBackspace %W
		tk_entrySeeCaret %W
	}

	bind $aWIDGET <Any-KeyPress> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}	


	bind $aWIDGET <KeyPress-a> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-b> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-c> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-d> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-e> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-f> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-g> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-h> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-i> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-j> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-k> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-l> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-m> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-n> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-o> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-p> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-q> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-r> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-s> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-t> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-u> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-v> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-w> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-x> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-y> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-z> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}

	bind $aWIDGET <KeyPress-A> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-B> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-C> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-D> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-E> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-F> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-G> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-H> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-I> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-J> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-K> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-L> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-M> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-N> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-O> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-P> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-Q> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-R> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-S> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-T> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-U> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-V> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-W> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-X> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-Y> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
	bind $aWIDGET <KeyPress-Z> {
		%W insert insert %A
		tk_entrySeeCaret %W
	}
}


proc HangulBind {aWIDGET} {

	InitHanAutomata;
	$aWIDGET configure -kanjifont -kaist-myungjo-medium-r-normal--16-120-100-100-c-160-ksc5601.1987-0;

	bind $aWIDGET <Shift-space> {
		HangulUnBind %W
	}

	bind $aWIDGET <1> {
		%W icursor @%x
		%W select from @%x
		if {[lindex [%W config -state] 4] == "normal"} {
			focus %W
		}
		InitHanAutomata
	}

	bind $aWIDGET <2> {
		if { [catch {set newkey [selection get]} ]} {
			return
		}
		%W insert insert $newkey
		InitHanAutomata
	}

	bind $aWIDGET <BackSpace> {
		tk_entryBackspace %W
		tk_entrySeeCaret %W
		InitHanAutomata;
	}

	bind $aWIDGET <Any-KeyPress> {
		if [expr [expr [string compare %K "Shift_L"] == 0] || \
				[expr [string compare %K "Shift_R"] == 0] ] {
		} else {
			%W insert insert %A
			tk_entrySeeCaret %W
			InitHanAutomata
		}
	}	

	bind $aWIDGET <KeyPress-a> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-b> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-c> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-d> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-e> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-f> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-g> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-h> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-i> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-j> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-k> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-l> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-m> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-n> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-o> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-p> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-q> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-r> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-s> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-t> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-u> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-v> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-w> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-x> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-y> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-z> {HangulCompose %W %A}

	bind $aWIDGET <KeyPress-A> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-B> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-C> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-D> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-E> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-F> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-G> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-H> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-I> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-J> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-K> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-L> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-M> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-N> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-O> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-P> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-Q> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-R> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-S> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-T> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-U> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-V> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-W> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-X> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-Y> {HangulCompose %W %A}
	bind $aWIDGET <KeyPress-Z> {HangulCompose %W %A}
}

